package com.jasamedika.medifirst2000.service;

import java.text.ParseException;
import java.util.Date;
import java.util.List;
import java.util.Map;

import org.springframework.orm.jpa.JpaSystemException;

import com.jasamedika.medifirst2000.entities.LogbookKinerja;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.vo.LogbookKinerjaVO;
import com.jasamedika.medifirst2000.vo.SkorDokterVO;

public interface LogbookKinerjaService extends BaseVoService<LogbookKinerja, LogbookKinerjaVO, String> {

	public LogbookKinerjaVO verify(LogbookKinerjaVO vo) throws JpaSystemException, ServiceVOException;

	public LogbookKinerjaVO addPengajuanKontrakKinerja(LogbookKinerjaVO vo)
			throws JpaSystemException, ServiceVOException;

	public LogbookKinerjaVO updatePengajuanKontrakKinerja(LogbookKinerjaVO vo)
			throws JpaSystemException, ServiceVOException;

	public List<Map<String, Object>> findPengajuanKontrakKinerja(Integer idPegawai, Integer idJabatan)
			throws JpaSystemException;

	public List<Map<String, Object>> findDupKontrakKinerja(Integer idPegawai, Integer idJabatan, Long bulan,
			Integer idIndikator) throws JpaSystemException;

	public Map<String, Object> findKontrakKinerja(Integer idPegawai, Integer idJabatan, Long bulan)
			throws JpaSystemException;

	public List<Map<String, Object>> findKontrakKinerja(Integer idIndikator) throws JpaSystemException;

	public Map<String, Object> findLogbookKinerja(Integer idPegawai, Integer idJabatan, Long bulan)
			throws JpaSystemException;

	public List<Map<String, Object>> findAksesPegawai(Integer idPegawai, List<Integer> listIdKelompokJabatan);

	public List<Map<String, Object>> findLogbookJamKerjaDokter(Integer idPegawai, Long bulan);

	public List<Map<String, Object>> findLogbookLuarJamKerjaDokter(Integer idPegawai, Long bulan);

	public List<Map<String, Object>> findDetailLogbookJamKerjaDokter(Integer idPegawai, Integer idIndikator,
			Integer idProduk, String tglPelayanan, Integer idJenisPetugas, Double skor);

	public List<Map<String, Object>> findDetailLogbookLuarJamKerjaDokter(Integer idPegawai, Integer idIndikator,
			Integer idProduk, String tglPelayanan, Integer idJenisPetugas, Double skor);

	public Map<String, Object> findPenilaianKinerja(Integer idPegawai, Integer idJabatan, Long bulan)
			throws JpaSystemException;

	public List<Map<String, Object>> findRekapPenilaianKinerja(Long bulan, Integer idUnitKerja, Integer idSubunitKerja,
			Integer idPegawai) throws JpaSystemException;

	public void autoVerifKontrakJamKerjaDokter(Date bulan);
	
	public void autoVerifLogbookJamKerjaDokter(Date bulan);

	public List<SkorDokterVO> hitungTargetSkorLogbookDokter(String bulanAwal, String bulanAkhir) throws ParseException;

	public List<Double> findBobotJenisJabatan(Long periode, Integer idJabatan);

	public List<Map<String, Object>> findJabatanKontrakVerifKinerja(Integer idPegawai, Integer idPegawaiLogin);

	public List<Map<String, Object>> findLogbookPerawat(Integer idPegawai, Long bulan);

	public List<Map<String, Object>> findDetailLogbookPerawat(Integer idPegawai, Integer idProduk, String tglPelayanan);

	public List<Map<String, Object>> findLogbookNakes(Integer idPegawai, Long bulan);

	public List<Map<String, Object>> findDetailLogbookNakes(Integer idPegawai, Integer idProduk, String tglPelayanan);

	public List<Map<String, Object>> findLogbookFarmakologi(Integer idPegawai, Long bulan);

	public List<Map<String, Object>> findDetailLogbookFarmakologi(Integer idPegawai, Integer idProduk,
			String tglPelayanan);
	
	public List<Map<String, Object>> findJabatanByLogbookPegawai(Integer idPegawai, Long bulan);

}
